/* -*-c++-*- */
#ifndef O3GBFARGMAX_H
#define O3GBFARGMAX_H
/* O3GBFArgmax : The third-order grandchild parser, implemented as a
   bottom-up non-pruned parser. */

#include "O3Argmax.h"

template<class PartScorer>
class o3gbfargmax : public o3argmax<PartScorer> {
public:
  o3gbfargmax();
  virtual ~o3gbfargmax();

protected:
  typedef class o3argmax<PartScorer>::state state;
  virtual double impl(const state& restrict X,
                      const bool multiroot) const;
};

#ifndef EXPLICIT_TEMPLATES
#include "O3GBFArgmax.tcc"
#endif /* EXPLICIT_TEMPLATES */

#endif /* O3GBFARGMAX_H */
