#include "O3ParamsAvg.h"

#include <assert.h>
#include <string.h>
#include <math.h>


o3params_avg::o3params_avg(const int L)
  : o3params<avg_param,avg_param_util>(L),
    _now(0) {}
o3params_avg::~o3params_avg() {}


void o3params_avg::avg_flush() {
  for(int i = 0; i < _nW; ++i) {
    primals& W = _W_arr[i];
    primals::iterator it = W.begin();
    const primals::iterator iend = W.end();
    for(; it != iend; ++it) {
      avg_param& p = it->val;
      p.update(_now);
      /* reset the timestamp since everything is up-to-date */
      p._timestamp = 0;
    }
  }
  _now = 0;
}
