/* -*-c++-*- */
#ifndef O3SBFARGMAX_H
#define O3SBFARGMAX_H
/* O3SBFArgmax : The third-order sibling parser, implemented as a
   bottom-up non-pruned parser. */

#include "O3Argmax.h"

template<class PartScorer>
class o3sbfargmax : public o3argmax<PartScorer> {
public:
  o3sbfargmax();
  virtual ~o3sbfargmax();

protected:
  typedef class o3argmax<PartScorer>::state state;
  virtual double impl(const state& restrict X,
                      const bool multiroot) const;
};

#ifndef EXPLICIT_TEMPLATES
#include "O3SBFArgmax.tcc"
#endif /* EXPLICIT_TEMPLATES */

#endif /* O3SBFARGMAX_H */
